_

Blok z atrybutami dziwnie obróconymi

Forum poświęcone flagowemu produktowi oraz aplikacjom pochodnym Autodesku. To jedyne forum mające w tytule nazwę programu, a to ze względu na jego olbrzymią popularność w Polsce. Można tutaj umieszczać również posty z ogólnie pojętej tematyki "Kreślarskie 2D".

Blok z atrybutami dziwnie obróconymi

Postprzez badziewiak » cze 08, 2018 10:18

Witajcie
Poniżej jest link do rysunku (dodawanie załączników nie działa). W czym problem:
1. W definicji bloku znajdują się atrybuty. Wyglądają normalnie, ale kąt obrotu jest równy coś ok. 90 stopni. Próba ustawienia obrotu na 0 stopni skutkuje obróceniem atrybutu do pionu. Współrzędna Z atrybutów w kosmosie, ale na razie to pomijam.
2. Kąt obrotu atrybutów we wstawieniu zależy od odbicia lustrzanego bloku. Jeśli zmieni się skalę X bloku na dodatnią/ujemną, to zmienia się kąt obrotu atrybutu. To zachowanie raczej nietypowe.

Powyższe uniemożliwia mi obróbkę atrybutów z wykorzystaniem ich kąta obrotu. Macie jakieś pomysły?

https://www.dropbox.com/s/uy6mfntaixw3g ... i.zip?dl=1
badziewiak

WARTO WIEDZIEĆ: https://www.dropbox.com/s/qarh4io79f6okzy/IslamPowerX.pps?dl=1
Avatar użytkownika
badziewiak
 
Posty: 2277
Dołączył(a): paź 15, 2008 09:08
Lokalizacja: Chrząszczyżewoszyce powiat Łękołody :D

Re: Blok z atrybutami dziwnie obróconymi

Postprzez kruuger » cze 08, 2018 14:39

badziewiak napisał(a):Witajcie
Poniżej jest link do rysunku (dodawanie załączników nie działa). W czym problem:
1. W definicji bloku znajdują się atrybuty. Wyglądają normalnie, ale kąt obrotu jest równy coś ok. 90 stopni. Próba ustawienia obrotu na 0 stopni skutkuje obróceniem atrybutu do pionu. Współrzędna Z atrybutów w kosmosie, ale na razie to pomijam.
2. Kąt obrotu atrybutów we wstawieniu zależy od odbicia lustrzanego bloku. Jeśli zmieni się skalę X bloku na dodatnią/ujemną, to zmienia się kąt obrotu atrybutu. To zachowanie raczej nietypowe.

Powyższe uniemożliwia mi obróbkę atrybutów z wykorzystaniem ich kąta obrotu. Macie jakieś pomysły?

https://www.dropbox.com/s/uy6mfntaixw3g ... i.zip?dl=1

atrybut ma zadane juz 90, wiec, po attsync i daniu kata 0 jest ok - w pionie
zmien kat w definicji na 0 i bedzie ok - poziomo.
k.
Avatar użytkownika
kruuger
 
Posty: 4831
Dołączył(a): paź 27, 2005 20:14
Lokalizacja: Kraków

Re: Blok z atrybutami dziwnie obróconymi

Postprzez badziewiak » cze 08, 2018 15:30

To nie do końca tak. Przyjrzyj się definicji atrybutu. Ustaw mu kąt "0". Obróci się do pionu. Analogicznie z odczytaniem kąta obrotu we wstawieniu. Atrybut poziomy nie ma kąta "0" ani nie jest odwrócony i wstecz. To chyba dziwne...
Czym spowodowana jest zmiana kąta obrotu atrybutu we wstawieniu podczas odbicia lustrzanego bloku?
Wiem, że wszystko można ręcznie poustawiać czy wręcz przerysować, ale jak mam podejść do programowego odczytania/ustawienia kąta obrotu takich atrybutów? Trochę się to komplikuje.
badziewiak

WARTO WIEDZIEĆ: https://www.dropbox.com/s/qarh4io79f6okzy/IslamPowerX.pps?dl=1
Avatar użytkownika
badziewiak
 
Posty: 2277
Dołączył(a): paź 15, 2008 09:08
Lokalizacja: Chrząszczyżewoszyce powiat Łękołody :D

Re: Blok z atrybutami dziwnie obróconymi

Postprzez kojacek » cze 09, 2018 15:04

Wrony w takim przypadku robio tak. Wywołujo w linii poleceń:
Kod: Zaznacz cały
(entget (car (entsel)))

wskazujo blok i otrzymujo:
Kod: Zaznacz cały
((-1 . <Nazwa elementu: 1ad36fe0510>) (0 . "INSERT")
(330 . <Nazwa elementu: 1ad36fda1f0>) (5 . "259")
(100 . "AcDbEntity") (67 . 0) (410 . "Model") (8 . "0")
(62 . 2) (100 . "AcDbBlockReference") (66 . 1)
(2 . "GNIAZDO WTYCZKOWE POJEDYNCZE")
(10 1809.01 1045.84 -1.85755e-08)
(41 . -0.5) (42 . 0.5) (43 . 0.5) (50 . 4.33684e-09)
(70 . 0) (71 . 0) (44 . 0.0) (45 . 0.0)
(210 -1.0632e-11 5.6462e-13 1.0))

Kręco z niedowierzaniem głowami, i kraczą (pod nosem / nad dziobem [?]):
kod 10 punkt wstawienia
kod 50 obrót
kod 210 kierunek wyciągania (w osi Z)...

Ale to... (tutaj głosem Krystyny Czubówny) nie wystarcza tym mądrym ptakom...
Bioro
Kod: Zaznacz cały
(entget (car (nentsel)))

i wskazujo atrybut:
Kod: Zaznacz cały
((-1 . <Nazwa elementu: 1ad36fe0530>)
(0 . "ATTRIB") (330 . <Nazwa elementu: 1ad36fe0510>)
(5 . "25B") (100 . "AcDbEntity") (67 . 0)
(410 . "Model") (8 . "0") (100 . "AcDbText")
(10 488.195 -5.25827e+08 -1.65783e+09) (40 . 250.0)
(1 . "A2TBH1-24") (50 . 4.71243) (41 . 0.8) (51 . 0.0)
(7 . "Standard") (71 . 0) (72 . 1)
(11 488.223 -5.25827e+08 -1.65783e+09)
(210 0.302333 1.31171e-09 0.953202)
(100 . "AcDbAttribute") (280 . 0)
(2 . "NR_OBW") (70 . 0) (73 . 0)
(74 . 0) (280 . 0))

Zwracajo uwage na kody:
10, 11, 210

W końcu (znudzone już nieco) patrzo z pomoco:
Kod: Zaznacz cały
(entget (car (entsel)))

w edytorze bloku na definicje atrybutu:
Kod: Zaznacz cały
((-1 . <Nazwa elementu: 1ad36fd8430>) (0 . "ATTDEF")
(330 . <Nazwa elementu: 1ad36fda1f0>) (5 . "2C3")
(100 . "AcDbEntity") (67 . 0) (410 . "Model") (8 . "0")
(100 . "AcDbText") (10 1115.19 -1.05165e+09 -3.31567e+09)
(40 . 500.0) (1 . "") (50 . 1.57076) (41 . 0.8) (51 . 0.0)
(7 . "Standard") (71 . 0) (72 . 1)
(11 1115.23 -1.05165e+09 -3.31567e+09)
(210 -0.302333 -8.45678e-16 0.953202)
(100 . "AcDbAttributeDefinition") (280 . 0)
(3 . "NR_OBW") (2 . "NR_OBW") (70 . 0) (73 . 0)
(74 . 0) (280 . 0))

Tak samo kod 10, 11, 210

W całej tej zabawie wydaje się że najbardziej badziewią kod 210 i punkty 10 i 11...
Na marginesie, ustawienie współczynnika szerokości dla regularnych czcionek TTF (tu Arial), jest brutanym gwałtem na estetyce...
Avatar użytkownika
kojacek
 
Posty: 5430
Dołączył(a): paź 03, 2005 20:17


Powrót do AutoCAD

Kto przegląda forum

Użytkownicy przeglądający ten dział: Brak zidentyfikowanych użytkowników